﻿namespace HeuristicLab.BenchmarkSuite.ProblemData {
  using HeuristicLab.Algorithms.PushGP.Interpreter;

  public class MirrorImagePushData : Data<long[][], bool>, IPushData {
    public MirrorImagePushData(Example<long[][], bool>[] training, Example<long[][], bool>[] test)
      : base(training, test, 0, 50) {
    }

    public void ApplyTrainingInput(IPushGpInterpreter interpreter, int index) {
      interpreter.IntegerStack.Push(Training[index].Input[0]);
      interpreter.IntegerStack.Push(Training[index].Input[1]);
    }

    public void ApplyTestInput(IPushGpInterpreter interpreter, int index) {
      interpreter.IntegerStack.Push(Test[index].Input[0]);
      interpreter.IntegerStack.Push(Test[index].Input[1]);
    }

    public double CompareTrainingOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.BooleanStack,
        index,
        this.Training,
        data => data == interpreter.BooleanStack.Top ? 1 : 0);
    }

    public double CompareTestOutput(IPushGpInterpreter interpreter, int index) {
      return this.CompareOutput(
        interpreter.BooleanStack,
        index,
        this.Test,
        data => data == interpreter.BooleanStack.Top ? 1 : 0);
    }
  }
}
