﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  using HeuristicLab.BenchmarkSuite.ProblemData;

  public class ReplaceSpaceWithNewline : BenchmarkSuiteDataDescriptor<string, string[]> {
    private const string displayMame = "Replace Space with Newline";
    private const string description = "Given a string input, print the string, replacing spaces with newlines.Also, return the integer count of the non- whitespace characters. The input string will not have tabs or newlines.";

    public override string Name { get { return displayMame; } }
    public override string Description { get { return description; } }
    protected override int InputCount { get { return 1; } }
    protected override int OutputCount { get { return 2; } }

    public override string ConvertInput(string[] input) {
      return input[0];
    }

    public override string[] ConvertOutput(string[] output) {
      return output;
    }

    public override IPushData CreatePushData(Example<string, string[]>[] training, Example<string, string[]>[] test) {
      return new ReplaceSpaceWithNewlinePushData(training, test);
    }
  }
}
